/**
 * Arduino latency testing code -- target device
 *
 * This code performs the simple function of notifying the host
 * via the Serial port when a pin has gone high. There are two
 * approaches that can be selected: either a message only when
 * the event takes, or a continuous loop of readings.
 *
 * (c) 2015 Andrew McPherson, C4DM, QMUL
 * This is licensed under a Creative Commons Attribution-ShareAlike licence.
 */
 
#undef PRINT_ALWAYS

const int gInputPin = 2;
const long gSerialSpeed = 115200;  // It may be worth testing different speeds

void setup() {
  Serial.begin(gSerialSpeed);
  pinMode(gInputPin, INPUT);
}

void loop() {
#ifdef PRINT_ALWAYS
  Serial.println(digitalRead(gInputPin));
  // Optionally a (small!) delay here if the port gets overloaded
  // delay(5);
#else
  // Wait for pin to go high, print trigger, then wait for it to go low again
  while(digitalRead(gInputPin) == LOW) {}
  Serial.println("1");
  while(digitalRead(gInputPin) == HIGH) {}
#endif
}
