/**
 * Arduino latency testing code -- target device
 *
 * This code performs the simple function of notifying the host
 * via the Serial port when a pin has gone high. There are two
 * approaches that can be selected: either a message only when
 * the event takes, or a continuous loop of readings.
 *
 * (c) 2015 Andrew McPherson, C4DM, QMUL
 * This is licensed under a Creative Commons Attribution-ShareAlike licence.
 */
 
const int gInputPin = 2;

void setup() {
  pinMode(gInputPin, INPUT);
}

void loop() {
  // Wait for pin to go high, print trigger, then wait for it to go low again
  while(digitalRead(gInputPin) == LOW) {}
  usbMIDI.sendNoteOn(84, 127, 1); 
  while(digitalRead(gInputPin) == HIGH) {}
}
